import { CalculatorPage } from "./calculator.po";
import { ListPage } from "./list.po";
import { Navbar } from "./navbar.po";
import { PreferencesPage } from "./preferences.po";
import { browser, $, $$, expect } from '@wdio/globals'
import { newSession, openCalculator } from "./util.po";
import { SideNav } from "./sidenav.po";

describe("linked parameter - ", () => {
    let calcPage: CalculatorPage;
    let prefPage: PreferencesPage;
    let navBar: Navbar;
    let listPage: ListPage;
    let sideNav: SideNav;

    beforeAll(() => {
        calcPage = new CalculatorPage();
        prefPage = new PreferencesPage();
        navBar = new Navbar();
        listPage = new ListPage();
        sideNav = new SideNav();
    });

    beforeEach(async () => {
        // browser.manage().window().setPosition(2000, 30);

        // disable evil option "empty fields on module creation"
        await prefPage.navigateTo();
        await prefPage.disableEvilEmptyFields();
        await browser.pause(200);
        await navBar.clickNewCalculatorButton();
    });

    it("delete linked module", async () => {
        // open "channel flow with hydraulic structures" example
        const examples = await $$("#examples-list .load-example");
        await examples[1].click();
        await browser.pause(500);

        // select "up/downstream elevations of a reach" tab
        await navBar.clickCalculatorTab(1);
        await browser.pause(500);

        // close "solver" calculator
        await navBar.middleClickCalculatorTab(3);

        // reselect "up/downstream elevations of a reach" tab
        await navBar.clickCalculatorTab(1);
        await browser.pause(500);

        // close second "parallel structures" calculator
        await navBar.middleClickCalculatorTab(2);

        // close first "parallel structures" calculator
        await navBar.middleClickCalculatorTab(0);

        // check Z2 input is in "fixed" state in remaining calculator
        const inpZ2 = await calcPage.getInputById("Z2");
        expect(await calcPage.inputIsInFixedMode(inpZ2)).toBe(true);
    });
});
